Subject: Re: Pretty format specifier for commit count?

From: Michael J Gruber <[email-masked]>
Date: Mon, 19 Jan 2015 14:54:13 +0100

Josh Triplett schrieb am 19.01.2015 um 02:29:
> I'd like to use git-log to generate a Debian changelog file (with one
> entry per commit), which has entries like this:
> 
> package-name (version-number) unstable; urgency=low
> 
>  * ...
> 
>  -- Example Person <[email-masked]>  RFC822-date
> 
> Since I'm intentionally generating one entry per commit, I can generate
> *almost* all of this with git log:
> 
> git log --pretty='format:packagename (FIXME) unstable; urgency=low%n%n  * %s%n%w(0,4,4)%+b%w(0,0,0)%n -- %an <%ae>  %aD%n'
> 
> This produces entries like this:
> 
> packagename (FIXME) unstable; urgency=low
> 
>   * Example change
> 
>     Long description of example change.
> 
>  -- Josh Triplett <[email-masked]>  Thu, 8 Jan 2015 16:36:52 -0800
> 
> packagename (FIXME) unstable; urgency=low
> 
>   * Initial version
> 
>  -- Josh Triplett <[email-masked]>  Thu, 8 Jan 2015 16:36:51 -0800
> 
> Would it be possible to add a format specifier producing a commit count,
> similar to that provided by git-describe?  Such a specifier would allow
> filling in the version number in the format above (replacing the FIXME).
> (Note that the version numbers need to monotonically increase; otherwise
> I would just use the commit hash as the version numer.)
> 
> - Josh Triplett
> 

Can you be a bit more specific about the type count that you are after?
"git describe" counts commits since the most recent tag (possibly within
a specific subset of all tags). Is that your desired format?

(I won't suggest scripting around rev-list, describe and log -1 because
you know that already...)

Michael